#include<bits/stdc++.h>
using namespace std;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, m;cin>>n >>m;
	vector<tuple<int,int,int>> g;

	for(int i = 0;i < m;i ++) {
		int a, b, y, _;
		cin >> a >> y >> b >> _;
		g.push_back({y, a-1, b-1});
	}

	vector<int> ans(n);
	sort(g.begin(), g.end());
	iota(ans.begin(), ans.end(), 0);
	for (auto &&[y, a, b] : g) {
		swap(ans[a], ans[b]);
	}
	vector<int> aans(n);
	for (int i = 0; i < ans.size();i++) {
		aans[ans[i]] = i+1;
	}
	for (auto i : aans) cout << i << "\n";
}
